import React, { ReactNode, ReactElement } from "react";
import { User } from "./interface/User.interface";
interface AuthContextType {
    user: User | null;
    isAuthenticated: boolean;
    isLoading: boolean;
    signIn: (email: string, password: string) => Promise<void>;
    signOut: () => void;
}
export declare const useAuth: () => AuthContextType;
export declare function withAuth<T>(Component: React.ComponentType<T>): (props: T) => ReactElement;
interface AuthProviderProps {
    children: ReactNode;
}
export declare const AuthProvider: React.FC<AuthProviderProps>;
export {};
