"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var useLogTable_1 = require("./useLogTable");
describe('logAsTable', function () {
    beforeEach(function () {
        console.log = jest.fn();
        console.error = jest.fn();
        console.table = jest.fn();
    });
    it('logs a valid object with emojis as an array', function () {
        var testObj = { key1: 'value1', key2: 'value2' };
        var emojis = ['😀', '😃'];
        (0, useLogTable_1.logAsTable)(testObj, emojis);
        expect(console.table).toHaveBeenCalledWith(expect.anything());
    });
});
describe('log', function () {
    beforeEach(function () {
        console.log = jest.fn();
        console.error = jest.fn();
    });
    it('logs a valid object with emojis as an array', function () {
        var testObj = { key1: 'value1', key2: 'value2' };
        var emojis = ['😀', '😃'];
        (0, useLogTable_1.log)(testObj, emojis);
        expect(console.log).toHaveBeenCalledWith(expect.anything());
    });
});
